import java.util.Scanner;

public class Mavenproject4 {

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);

        int N = in.nextInt();
        int Q = in.nextInt();
        int[] dani = new int[N];
        int[] plazma = new int[N];

        for (int i = 0; i < N; i++) {
            dani[i] = in.nextInt(); //dani kada je cale nasao plazmu
            plazma[i] = in.nextInt(); //koliko je plazmi kupio kada ju je nasao
        }
        int[] Pitanja = new int[Q]; //pravi niz koji se sastoiji od Q pitanja
        for (int i = 0; i < Q; i++) {
            Pitanja[i] = in.nextInt();
        }
        int[] ukupnaPlazma = new int[N];
        ukupnaPlazma[0] = plazma[0];
        for (int i = 1; i < N; i++) {
            ukupnaPlazma[i] = ukupnaPlazma[i - 1] + plazma[i];
        }
        for (int pitanje : Pitanja) { //obrada pitanja
            //Pronalazi posledji dan koji je manji ili jednak pitanju
            int result = 0;
            for (int i = 0; i < N; i++) {
                if (dani[i] <= pitanje) {
                    result = ukupnaPlazma[i];
                } else {
                    break;
                }

            }
            System.out.println(result);
        }
    }
}